plugins {
    application
    kotlin("jvm") version "1.5.10"
    kotlin("plugin.serialization") version "1.5.10"
    id("com.github.johnrengelman.shadow") version "7.0.0"
}

buildscript {
    repositories { mavenCentral() }

    dependencies {
        val kotlinVersion = "1.5.10"
        classpath(kotlin("gradle-plugin", version = kotlinVersion))
        classpath(kotlin("serialization", version = kotlinVersion))
    }
}

application {
    mainClassName = "MainKt"
}

group = "com.kmlabz"
version = "1.0-SNAPSHOT"

repositories {
    mavenCentral()
    jcenter()
}

dependencies {
    implementation("com.rabbitmq:amqp-client:5.13.0")
    implementation("com.viartemev:the-white-rabbit:0.0.6")
    implementation("com.zaxxer:HikariCP:5.0.0")
    implementation("org.jetbrains.kotlinx:kotlinx-serialization-json:1.2.2")
    implementation("org.jetbrains.kotlinx:kotlinx-datetime:0.2.1")
    implementation("org.jetbrains.exposed:exposed-core:0.33.1")
    implementation("org.jetbrains.exposed:exposed-dao:0.33.1")
    implementation("org.jetbrains.exposed:exposed-jdbc:0.33.1")
    implementation("org.jetbrains.exposed:exposed-java-time:0.33.1")
    implementation("io.insert-koin:koin-core:3.1.2")
    implementation("org.postgresql:postgresql:42.2.23")
}

tasks {
    named<com.github.jengelman.gradle.plugins.shadow.tasks.ShadowJar>("shadowJar") {
        archiveBaseName.set("output-service-rdb-consumer")
        classifier = null
        version = null
        mergeServiceFiles()
        manifest {
            attributes(mapOf("Main-Class" to "Main"))
        }
    }
    compileKotlin {
        kotlinOptions.jvmTarget = "11"
    }
}
